<?
/**
 * @package SysInfoWidget
 * @author Akash Heimlich
 * @description This widget shows system info on the screen
 */
 
// this will take care of the package management functions and call the right function based on the get parameters

    include("/app/package.inc"); 
    
    function SysInfoWidget_install($val) {
        SysInfoWidget_enable();
        return 1;
    }
     
    function SysInfoWidget_uninstall() {
        setPackageStatus("SysInfoWidget",0);
        return 1;
    }
    
    function SysInfoWidget_enable() {
        setPackageStatus("SysInfoWidget",2);
        addWidget("/package/SysInfoWidget.inc","System Information",4,"icon-play",1,0); // enable
        return 1;
    }
    
    function SysInfoWidget_disable() {
        setPackageStatus("SysInfoWidget",3);
        addWidget("/package/SysInfoWidget.inc","System Information",4,"icon-play",1,1); // disable
        return 1;
    }
    
    /* this is called at system boot */
    function SysInfoWidget_init() {
        
        // generate ajax data for front end processing
        if (file_exists('/package/SysInfoWidgetAjax.inc')) 
            $_GLOBALS['hooks']['ajax'][]='/package/SysInfoWidgetAjax.inc';

        return 1;
    }
    
    function SysInfoWidget_configure() {
        $_GLOBALS['sysmsg']='This package has no configuration options';
        header("Location:/app/pacman.cgi");
        return 1;
    }
    execute(); // process the package and run the correct function
    
?>